<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Temple extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('temple_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->temple_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Temple Details';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_master_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '1');
        $this->render($data, 'temple/list');
    }
    
    private function get_temple_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->temple_model->temple_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_temple_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'temple/add');
    }
    
    public function insert() {
        $insert = array(
            'no' => $this->input->post('temple_no'),
            'name' => $this->input->post('name'),
            'tamil_name'=> htmlspecialchars( $this->input->post('tamil_name') ),
            'chairman_name' => $this->input->post('chairman'),
            'chair_tamil_name' => htmlspecialchars( $this->input->post('chairman_tamil') ),
            'phone' => $this->input->post('phone_no'),
            'fax' => $this->input->post('fax'),
            /* 'unit_no' => $this->input->post('unit_no'),
            'blk'=> $this->input->post('blk'), */
            'email' => $this->input->post('email'),
            //'website' => $this->input->post('website'),
            'address' => $this->input->post('address'),
            'url_key' => $this->get_temple_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->temple_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Temple Details added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Temple Details not added!');
        redirect('temple', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['temple'] = $this->temple_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'temple/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'no' => $this->input->post('temple_no'),
            'name' => $this->input->post('name'),
            'tamil_name'=> htmlspecialchars( $this->input->post('tamil_name') ),
            'chairman_name' => $this->input->post('chairman'),
            'chair_tamil_name' => htmlspecialchars( $this->input->post('chairman_tamil') ),
            'phone' => $this->input->post('phone_no'),
            'fax' => $this->input->post('fax'),
            /* 'unit_no' => $this->input->post('unit_no'),
            'blk'=> $this->input->post('blk'), */
            'email' => $this->input->post('email'),
            //'website' => $this->input->post('website'),
            'address' => $this->input->post('address'),
            'url_key' => $this->get_temple_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->temple_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Temple Details updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Temple Details not updated!');    
        
        redirect('temple','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['temple'] = $this->temple_model->get_by_id($id);
        $this->render($data, 'temple/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->temple_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Temple Details deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Temple Details not deleted!');
        
        redirect( 'temple', 'refresh');
    }
}
?>